#include "model.h"

#include <stdlib.h>

struct expression *
alloc_expr ()
{
	return (struct expression *)calloc (1, sizeof (struct expression));
}

struct expression *
expression_create_integer (int value)
{
	struct expression *expr = alloc_expr ();
	expr->type = EXPR_INT;
	expr->integer = value;
	return expr;
}

struct expression *
expression_create_floating (float value)
{
	struct expression *expr = alloc_expr ();
	expr->type = EXPR_FLOAT;
	expr->floating = value;
	return expr;
}

struct expression *
expression_create_binop (struct token *op, struct expression *left,
												 struct expression *right)
{
	struct expression *expr = alloc_expr ();
	expr->type = EXPR_BINOP;
	expr->binop.op = op;
	expr->binop.left = left;
	expr->binop.right = right;
	return expr;
}

struct expression *
expression_create_unop (struct token *op, struct expression *operand)
{
	struct expression *expr = alloc_expr ();
	expr->type = EXPR_UNOP;
	expr->unop.op = op;
	expr->unop.operand = operand;
	return expr;
}

struct expression *
expression_create_grouping (struct expression *value)
{
	struct expression *expr = alloc_expr ();
	expr->type = EXPR_GROUP;
	expr->grouping.value = value;
	return expr;
}
